<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: plugins/logic/functions.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: plugins/logic/functions.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>function setup(data) {
  db = data.db
}

function test(args, refs) {
  return new Promise((resolve, reject) => {
    log.info("test function", "called test function with args " + args)
  })
}

/**
* returns the number of milliseconds between midnight of January 1, 1970 and now
*/
function timestamp(args, refs) {
  return new Promise((resolve, reject) => {
    log.info("timestamp function", "called timestamp function with args " + args)
    const now = new Date()
    const millis = now.getTime()
    resolve(millis)
  })
}

/**
* returns place object for associated story and stage 
*
* @param {string} args.0 - story name
* @param {string} args.1 - stage number
*/
function getPlace(args, refs) {
  return new Promise((resolve, reject) => {
    // convert argument from string to number if possible
    //const _stage = (args[1] != "" &amp;&amp; Number(args[1])) ? Number(args[1]) : args[1]
    // search place associated with stage and story
    refs.db.places.find({ story: args[0], stage: String(args[1]) }, { _id: 0 })
      .then(result => {
        // throw error if no place found in mongo db
        if (!result.length) {
          reject(new Error(`getPlace function: no place for ${args[0]} ${args[1]}`));
        }
        return resolve(result[0])
      })
      .catch(error => {
        log.error("getPlace function", error)
        return resolve(undefined)
      })
  })
}

/**
* assigns intro and corresponding place to player 
* TODO: auf räume prüfen, nicht auf vergebene intors/storys
*
* @param {string} args - player
*/
function assignIntro(args, refs) {
  return new Promise((resolve, reject) => {
    let _player, _intro;
    refs.variables.get(args)
      .then(result => {
        _player = result
        // count how often each intro is assigned (exclude current player)
        return refs.db.player.c.aggregate([
          { $match: { $and: [{ story: { $in: ["intro_1", "intro_2", "intro_3"] } }] } },
          { $group: { _id: '$story', "count": { $sum: 1 } } },
          { $sort: { "count": 1 } }
        ]).toArray()
      })
      .then(result => {
        // zurück zum ursprünglichen intro, wenn man rausgeflogen ist
        if (["intro_1", "intro_2", "intro_3"].includes(_player.story)) {
          _intro = { _id: _player.story };
          return getPlace([_intro["_id"], "1"], refs)
        }

        // if all 3 intros are assigned return the least assigned
        if (result.length == 3) { _intro = result[0]; }
        // if not all intros are assigned, check wich one is not and return
        else {
          const assigned = result.map(a => a._id);
          if (!assigned.includes("intro_1")) { _intro = { _id: "intro_1" }; }
          else if (!assigned.includes("intro_2")) { _intro = { _id: "intro_2" }; }
          else if (!assigned.includes("intro_3")) { _intro = { _id: "intro_3" }; }
          else { reject(new Error(`assign intro function: found no intro`)); }
        }

        // return place for assigned intro
        return getPlace([_intro["_id"], "1"], refs)
      })
      .then(result => {
        const data = {
          story: _intro._id, stage: "1", status: "enqueued",
          place: result,
          timestamp: new Date().getTime()
        };
        return refs.db.player.set({ _id: _player._id }, data);
      })
      .then(result => {
        return resolve("done")
      })
      .catch(error => {
        log.error("assignIntro function", error)
        return resolve(undefined)
      })
  })
}


/**
* checks if player is the only one enqueued for room and if so writes waiting number 
*
* @param {string} args - player
*/
function checkQueue(args, refs) {
  return new Promise((resolve, reject) => {
    let _player;
    refs.variables.get(args)
      .then(result => {
        _player = result
        return refs.db.player.find({
          $and:
            [
              { "place.id": _player.place.id },
              { $or: [{ status: "enqueued" }, { status: "called" }] }
            ]
        })
      })
      .then(result => {
        if (result.length == 1) { // if player is the only one
          return refs.db.player.set({ _id: _player._id }, { "place.waiting_number": 0 });
        } else {
          return
        }
      })
      .then(result => {
        return resolve("done")
      })
      .catch(error => {
        log.error("assignIntro function", error)
        return resolve(undefined)
      })
  })
}

/**
* updates every waiting number for players enqueued for room
* @param {string} args - place id
*/
function updateQueue(args, refs) {
  return new Promise((resolve, reject) => {
    log.info("updateQueue function", "called with args " + args)
    return refs.db.player.c.find({
      $and:
        [
          { "place.id": args },
          { $or: [{ status: "enqueued" }, { status: "called" }] },
          { type: { $ne: "performer" } }
        ]
    }).sort({ timestamp: 1 }).toArray()
      .then(result => {
        let updates = [];
        if (result.length > 0) {
          for (let index = 0; index &lt; result.length; index++) {
            updates.push(refs.db.player.set({ _id: result[index][["_id"]] }, { "place.waiting_number": index }));
          }
        }
        Promise.all(updates)
      })
      .then(result => {
        return resolve("done")
      })
      .catch(error => {
        log.error("assignIntro function", error)
        return resolve(undefined)
      })
  })
}

/**
* assigns story and corresponding place to player 
*
* @param {string} args - player
*/
function assignStory(args, refs) {
  return new Promise((resolve, reject) => {
    let _player, _story;
    refs.variables.get(args)
      .then(result => {
        _player = result

        // count how often each story is assigned (exclude current player)
        return refs.db.player.c.aggregate([
          { $match: { $and: [{ story: { $in: ["story_1", "story_2", "story_3"] } }, { _id: { $ne: _player._id } }] } },
          { $group: { _id: '$story', "count": { $sum: 1 } } },
          { $sort: { "count": 1 } }
        ]).toArray()
      })
      .then(result => {

        // result auffüllen mit noch nicht zugewiesenen storys
        if (result.length != 3) {
          ["story_1", "story_2", "story_3"].forEach(story => {
            if (!result.some(element => element._id === story))
              result.unshift({ _id: story, count: 0 });
          });
        }

        // log.info("ASSIGN STORY RESULTS:", result)

        let options = ["story_1", "story_2", "story_3"];

        // entferne mögliche storys, falls ein player sie schon gespielt hat
        if ('cFlags' in _player) {
          if (_player.cFlags.includes("Story_1_C"))
            options = options.filter(item => item !== "story_1")
          if (_player.cFlags.includes("Story_2_C"))
            options = options.filter(item => item !== "story_2")
          if (_player.cFlags.includes("Story_3_C"))
            options = options.filter(item => item !== "story_3")
        }

        // zur ersten story gehen die spieler zu einer anderen raum als ihr intro
        if (_player.history.length == 2) {
          if ((_player.history.includes("intro_1")))
            options = options.filter(item => item !== "story_1")
          if ((_player.history.includes("intro_2")))
            options = options.filter(item => item !== "story_2")
          if ((_player.history.includes("intro_3")))
            options = options.filter(item => item !== "story_3")
        }

        // log.info("ASSIGN STORY AFTER FLAG FILTER OPTIONS:", options)

        if (options.length == 0) {
          log.error("ASSIGN STORY", "Player hat alle Storys durchgespielt und muss vllt Task C machen")
        }

        // die options liste mit der vergebene storys liste vergleichen und die erste auswählen
        for (let index = 0; index &lt; result.length; index++) {
          if (options.includes(result[index]._id)) {
            _story = { _id: result[index]._id }
            break;
          }
        }

        if (!_story._id) {
          log.error("ASSIGN STORY", "keine story zuweisbar, das sollte nicht passieren!!! wähle zufällige aus")
          _story = { _id: options[Math.floor(Math.random() * options.length)] }
        }

        log.info("ASSIGNED NEW STORY:", _story["_id"])

        // return place for assigned intro
        return getPlace([_story["_id"], "1"], refs)
      })
      .then(result => {
        const data = {
          story: _story._id, stage: "1", status: "enqueued",
          place: result,
          timestamp: new Date().getTime()
        };
        return refs.db.player.set({ _id: _player._id }, data);
      })
      .then(result => {
        return resolve("done")
      })
      .catch(error => {
        log.error("assignStory function", error)
        return resolve(undefined)
      })
  })
}

/**
* checks if player is the only one enqueued for room and if so writes waiting number 
*
* @param {string} args - player
*/
function getReader(args, refs) {
  return new Promise((resolve, reject) => {
    let _player;
    refs.variables.get(args[0])
      .then(result => {
        _player = result
        return refs.db.device.find({
          $and: [
            { "status.card_id": { $in: _player.card_id } },
            { name: { $in: ["Room_1_Reader", "Room_2_Reader", "Room_3_Reader", "Room_4_Reader", "Room_5_Reader", "Room_6_Reader", "Room_7_Reader"] } }
          ]
        })
      })
      .then(result => {
        //log.info("RESULT", result)
        if (!result.length) {
          log.error("getReader function", "no player found " + result)
        }
        return resolve(result[0]["name"])
      })
      .catch(error => {
        log.error("getReader function", error)
        return resolve(undefined)
      })
  })
}

/**
* BIN ICH DIE ERSTE SPIELER*IN UND IST Eine WEITERE MITSPIELER*INNEN MIT DER cFlag VORHANDEN (dann schreibe ich in ihr document, dass sie beim nächstenmal mit mir spielen)
*
*/
function assignTaskC(args, refs) {
  return new Promise((resolve, reject) => {
    let _player, _say, _place, _story;
    refs.variables.get(args[0])
      .then(result => {
        _player = result;
        _story = _player.cFlags[_player.cFlags.length - 1]; // TODO: eigentlich alle möglichen kominationen

        return refs.db.player.find({
          cFlags: _story,
          _id: { $ne: _player._id },
          history: { $ne: _story },
          c_task: { $exists: false }
        })
      })
      .then(result => {
        // log.info("assignTaskC", result)
        if (result.length == 0) {
          return resolve(undefined)
        }
        else {
          if (_story == 'Story_1_C') {
            _say = `${_player.lastname}, ${_player.firstname} und ${result[0].firstname}, ${result[0].lastname} bitte in Raum 5, ${_player.lastname}, ${_player.firstname} und ${result[0].firstname}, ${result[0].lastname}  bitte in Raum 5, Valerie Mohnhaupt bitte begeben sie sich in Raum 5, Valerie Mohnhaupt bitte in Raum 5 zur Gruppenaufgabe`
            _place = { id: 'Room_5' }
          }
          else if (_story == 'Story_2_C') {
            _say = `${_player.lastname}, ${_player.firstname} und ${result[0].firstname}, ${result[0].lastname}  bitte in Raum 2, ${_player.lastname}, ${_player.firstname} und ${result[0].firstname}, ${result[0].lastname}  bitte in Raum 2, Bea Gerber bitte begeben sie sich in Raum 2, Bea Gerber bitte in Raum 2 zur Gruppenaufgabe`
            _place = { id: 'Room_2' }
          }
          else if (_story == 'Story_3_C') {
            _say = `${_player.lastname}, ${_player.firstname} und ${result[0].firstname}, ${result[0].lastname}  bitte in Raum 7, ${_player.lastname}, ${_player.firstname} und ${result[0].firstname}, ${result[0].lastname}  bitte in Raum 7, Leon Walther bitte begeben sie sich in Raum 7, Leon Walther bitte in Raum 7 zur Gruppenaufgabe`
            _place = { id: 'Room_7' }
          }
          return refs.db.player.set({ '_id': result[0]._id }, { 'c_task': { assigned: 'player_2', story: _story, say: _say, place: _place } })
        }
      })
      .then(result => {
        // log.info("assignTaskC", result)
        if (!result) {
          return resolve(undefined)
        }
        else {
          return refs.db.player.set({ '_id': _player._id }, { 'c_task': { assigned: 'player_1', story: _story, place: _place } })
        }
      })
      .then(result => {
        if (!result) {
          return resolve('no')
        }
        else {
          return resolve('player_1')
        }
      })
      .catch(error => {
        log.error("assignTaskC function", error)
        return resolve(undefined)
      })
  })
}


/**
* returns database entry in places document based on a player property (e.g. area)
*/
function getLocationText(args, refs) {
  return new Promise((resolve, reject) => {
    let name = "getLocationText"
    let player = {}
    refs.variables.get(args[0])
      .then(result => {
        player = result
        return refs.db.data.find({ name: "places" })
      })
      .then(result => {
        if (result.length) {
          if (result[0].hasOwnProperty(args[1])) {
            location = result[0][args[1]]
          } else {
            log.error(name, args[1] + " not found in places document")
          }
        } else {
          log.error(name, "places document not found")
          return resolve(undefined)
        }
        if (player) {
          if (player.hasOwnProperty(args[2])) {
            return resolve(location[player[args[2]]])
          } else {
            log.error(name, player._id + " has no property " + args[2])
            return resolve(undefined)
          }
        } else {
          log.error(name, "reference not found: " + args[0])
          return resolve(undefined)
        }
      })
      .catch(error => {
        log.error(this.name, error)
        return resolve(undefined)
      })
  })
}

/**
*
* create a link to the login for the player that fills the login textfields with his/her telnumber and key
*/
function getLoginLink(args, refs) {
  return new Promise((resolve, reject) => {
    refs.variables.get(args[0])
      .then(player => {
        if (player) {
          let telnumber = player.telnumber.replace("+", "%2B")
          return resolve("https://patrol-berlin.de/angestellte/account/" + player.key + telnumber + "/")
        } else {
          return resolve(undefined)
        }
      })
      .catch(error => {
        log.error(this.name, error)
        return resolve(undefined)
      })
  })
}

/**
* cancel sessions based on player reference
*
* @param {string} args - player reference name
*/
function cancelPlayerSessions(args, refs) {
  return new Promise((resolve, reject) => {
    let name = "cancelPlayerSessions"

    let reference = refs.variables.getReference(args)

    if (!reference) {
      return reject(name + " " + args + " is not a valid reference")
    }

    let query = reference.query

    let collection = "player"
    let key = 'sessions._id'
    let value = query.sessions._id

    //log.info("REFERENCE", reference)

    let match = {}
    //match['player.sessions._id'] = query.sessions._id
    match[collection + '.' + key] = value

    // log.info("MATCH", match)

    if (!refs.db.hasOwnProperty(collection)) {
      //log.error(name, collection + " is not an existing collection")
      return reject(name + ": " + collection + " is not an existing collection")
    }

    refs.db.sessions.c.aggregate([{
      $lookup:
      {
        from: collection,
        localField: "_id",
        foreignField: "sessions._id",
        as: collection
      }
    },
    {
      $match: match
    },
    { $project: { _id: 1 } }
    ]).toArray()
      .then(result => {
        if (!result.length) {
          log.warn(name, key + ":" + value + " did not return any results in " + collection)
          return resolve(undefined)
        }
        let object_ids = []
        for (let res of result) {
          if (!refs._id.equals(res._id)) {
            object_ids.push(res._id)
          }
        }
        if (object_ids.length) {
          log.info(name, "cancel sessions with references to " + JSON.stringify(match))
          log.info(name, object_ids)
          refs.game_event.emit('cancel', { _id: { $in: object_ids } })
        } else {
          log.info(name, "no session to delete.")
        }
        return resolve(undefined)
      })
      .catch(error => {
        return reject(error)
      })
  })
}

/**
* cancel sessions based on references
*
* @param {string} args.0 - name of collection to find references in
* @param {string} args.1 - key part of query that finds documents in that collection
* @param {string} args.2 - value part of query that finds documents in that collection
*/
function cancelSessions(args, refs) {
  return new Promise((resolve, reject) => {
    let name = "cancelSessions"
    let collection = args[0]
    let key = args[1]
    let value = args[2]

    let match = {}
    match[collection + '.' + key] = value

    if (!refs.db.hasOwnProperty(collection)) {
      //log.error(name, collection + " is not an existing collection")
      return reject(name + ": " + collection + " is not an existing collection")
    }

    refs.db.sessions.c.aggregate([{
      $lookup:
      {
        from: collection,
        localField: "_id",
        foreignField: "sessions._id",
        as: collection
      }
    },
    {
      $match: match
    },
    { $project: { _id: 1 } }
    ]).toArray()
      .then(result => {
        if (!result.length) {
          log.warn(name, key + ":" + value + " did not return any results in " + collection)
          return resolve(undefined)
        }
        let object_ids = []
        for (let res of result) {
          object_ids.push(res._id)
        }
        log.info(name, "cancel sessions with references to " + JSON.stringify(match))
        log.info(name, object_ids)
        refs.game_event.emit('cancel', { _id: { $in: object_ids } })
        return resolve(undefined)
      })
      .catch(error => {
        return reject(error)
      })

    /*
    refs.db[collection].find(reference_query)
    .then(result => {
      if(!result.length) {
        log.warn(name, JSON.stringify(reference_query) + " did not return any results in " + collection)
        return resolve(undefined)
      }
      
      
    })
    .catch(error => {
      log.error(this.name, error)
    })
    */
  })
}

/**
* takes a cuename as argument and returns the time that passed since in the format hh:mm:ss
*/
function since(args, refs) {
  return new Promise((resolve, reject) => {
    since_cue = args[0]
    refs.db.sessions.find({ _id: refs.session })
      .then(result => {
        if (result.length) {
          if (result[0].hasOwnProperty(since_cue)) {
            let t = new Date(Date.now() - new Date(result[0][since_cue].date))
            let date_since = t.toTimeString()
            date_since = date_since.split(' ')[0]
            return resolve(date_since)
          } else {
            log.error("since function", "no such cue " + since_cue)
            return resolve(undefined)
          }
        } else {
          return resolve(undefined)
        }
      })
      .catch(error => {
        log.error(this.name, error)
      })
  })
}

/**
* checks if all roles of level are assigned to players
*/
function attendance(args, refs) {
  return new Promise((resolve, reject) => {
    let assigned;
    refs.db.player.distinct('sessions', { 'sessions._id': refs.session })
      .then(result => {
        assigned = result.reduce((results, item) => {
          if (item._id.equals(refs.session)) results.push(item.reference)
          return results
        }, []);
        return refs.db.sessions.distinct('config.player.name', { '_id': refs.session })
      })
      .then(cast => {
        for (let role of cast) {
          if (!assigned.includes(role)) {
            // log.info(this.name, `${refs.session} ${role} not assigned`);
            return resolve(false);
          }
        }
        // log.info(this.name, `${refs.session} all roles ${cast} assigned`)
        return resolve(true);
      })
      .catch(error => {
        log.error(this.name, error)
        return reject(error)
      })
  })
}


/**
* takes a cuename as argument and returns the time that passed since in the format hh:mm:ss
*/
function left(args, refs) {
  return new Promise((resolve, reject) => {
    if (args.length != 2) {
      log.error("left function", "takes exactly two arguments")
      return resolve(undefined)
    }
    since_cue = args[0]
    total_time = new Date(Number(args[1]) * 1000)
    refs.db.sessions.find({ _id: refs.session })
      .then(result => {
        if (result.length) {
          if (result[0].hasOwnProperty(since_cue)) {
            let t = new Date(Date.now() - new Date(result[0][since_cue].date))
            t = new Date(total_time - t)
            //t = total_time - t
            let date_since = t.toTimeString()
            date_since = date_since.split(' ')[0]
            return resolve(date_since)
          } else {
            log.error("since function", "no such cue " + since_cue)
            return resolve(undefined)
          }
        } else {
          return resolve(undefined)
        }
      })
      .catch(error => {
        log.error(this.name, error)
      })
  })
}

/**
* assign values for where training starts and in which area
* assign data from assignment docuemnt in data depending on the timeslot (timecode part of registration)
*/
function startValues(args, refs) {
  return new Promise((resolve, reject) => {
    var reference = refs.variables.getReference(args[0])
    if (!reference) {
      log.error(name, "coldnt resolve player reference " + args[0])
      return resolve(undefined)
    }

    var player = {}
    var assignments = {}
    var ass = {}
    var timeslot = ""

    refs.db.player.find(reference.query)
      .then(result => {
        if (!result.length) {
          log.error(name, "no player found by query: " + reference.query)
          return resolve(undefined)
        }
        player = result[0]

        return refs.db.data.find({ name: "assignments" })
      })
      .then(result => {
        timeslot = player.key.substring(6, 9)

        assignments = result[0]
        ass = assignments[timeslot]

        let start_values = { 'training.location': assignments.startpoints[ass.startpoint - 1], area: ass.area, timeslot: timeslot }
        log.info("startValues function", "assigning startvalues to " + player.telnumber + " " + player.name)
        log.info("startValues function", start_values)
        return refs.db.player.set(reference.query, start_values)
      })
      .then(result => {
        let rotate = {}

        if (ass.area == 1) {
          rotate[timeslot + '.area'] = 2

          if (ass.startpoint == 1) {
            rotate[timeslot + '.startpoint'] = 3
          } else if (ass.startpoint == 2) {
            rotate[timeslot + '.startpoint'] = 4
          }
        } else {
          rotate[timeslot + '.area'] = 1

          if (ass.startpoint == 3) {
            rotate[timeslot + '.startpoint'] = 2
          } else if (ass.startpoint == 4) {
            rotate[timeslot + '.startpoint'] = 1
          }
        }

        refs.db.data.set({ name: "assignments" }, rotate)
      })
      .then(result => {
        return resolve("done")
      })
      .catch(error => {
        log.error(this.name, error)
        return resolve(undefined)
      })
  })
}

/**
* move important data about recent/current job to central property so master level can see how to proceed
*
@* @returns {Promise} amount of jobs the player finished
*/
function jobData(args, refs) {
  return new Promise((resolve, reject) => {
    let name = "nextJob function"
    reference = refs.variables.getReference(args[0])
    if (!reference) {
      log.error(name, "coldnt resolve player reference " + args[0])
      return resolve(undefined)
    }

    var player = {}
    var finished = 0

    refs.db.player.find(reference.query)
      .then(result => {
        if (!result.length) {
          log.error(name, "no player found by query: " + reference.query)
          return resolve(undefined)
        }
        player = result[0]

        let data = {}
        // Overwrite job_data property with status etc of current job
        if (player.hasOwnProperty('current_job')) {
          if (player.hasOwnProperty(player.current_job)) {
            data = { job_data: player[player.current_job] }
          } else {
            log.error("jodData function", "no status values for current job in " + player.name + " " + player.telnumber)
            return resolve(undefined)
          }
        } else {
          log.error("jodData function", "current job property missing in " + player.name + " " + player.telnumber)
          return resolve(undefined)
        }

        // count finished jobs and write number to job data
        // Also calculate average score
        if (player.hasOwnProperty('finished_jobs')) {
          finished = player.finished_jobs.length

          if (finished > 1) {
            let avg_score = player.score / (finished - 1)
            data['score_average'] = Math.round(avg_score * 100) / 100
            if (player.language == "en") {
              data['score_average_formatted'] = data['score_average'].toLocaleString('en-GB')
            } else if (player.language == "de") {
              data['score_average_formatted'] = data['score_average'].toLocaleString('de-DE')
            }
          }
        }
        data.job_data['finished'] = finished

        return refs.db.player.set(reference.query, data)
      })
      .then(result => {
        if (result) {
          return resolve(finished)
        } else {
          log.error("jodData function", "something is missing to resolve job data")
          return resolve(0)
        }
      })
      .catch(error => {
        log.error(this.name, error)
      })
  })
}

/**
*
*/
function cooperation(args, refs) {
  return new Promise((resolve, reject) => {
    let name = "coopJob function"
    var reference = refs.variables.getReference(args[0])
    if (!reference) {
      log.error(name, "couldn't resolve player reference " + args[0])
      return resolve(undefined)
    }

    var player = {}
    var partner = {}
    var coop_job = ""

    return refs.db.player.find(reference.query)
      .then(result => {
        if (!result.length) {
          log.error(name, "no player found by query: " + JSON.stringify(reference.query))
          return undefined
        }

        player = result[0]

        let query = {
          name: { $not: { $in: player.finished_jobs } }, // player has not played level (obligatory)
          family: { $not: { $in: player.finished_jobs } }, // player has not played any level of the family (obligatory)
          'config.area': player.area, // level is in same area the player is in (obligatory)
          'config.type': 'cooperative', // obligatory
          'config.language': player.language, // obligatory
          //'config.group': { $ne: player.progress }, // obligatory
          // 'config.stage':player.stage, // level is of same stage the player is in
          $expr: { $lt: ["$instances", "$config.maxSessions"] } // find only levels where max number of players is not reached. Uses aggregate expression: https://docs.mongodb.com/manual/reference/operator/query/expr/
        }

        return refs.db.level.find(query)
      })
      .then(result => {
        if (!result) {
          return undefined
        }
        if (!result.length) {
          return undefined
        }
        coop_job = result[0].name
        log.debug(name, "Found free cooperation job: " + coop_job)
        return refs.db.player.find({ 'cooperation.status': 'available', area: player.area, language: player.language, _id: { $ne: player._id } })
      })
      .then(result => {
        if (!result) {
          return resolve(undefined)
        }
        if (!result.length) {
          return resolve(undefined)
        }
        log.debug(name, "Found partner " + result[0].name + " to play cooperation job " + coop_job + " with " + player.name)
        return resolve(arrangeCooperation(player, result[0], coop_job, args, refs))
      })
      .catch(error => {
        log.error(this.name, error)
        return resolve("error")
      })
  })
}

function arrangeCooperation(player, partner, coop_job, args, refs) {
  return new Promise((resolve, reject) => {
    refs.game_event.emit('create', {
      level: coop_job, player: { _id: player._id }, role: args[1], callback: session_id => {
        refs.db.player.set({ _id: partner._id }, { cooperation: { status: 'enqueued', session: session_id } })
          .then(result => {
            return refs.db.player.set({ _id: player._id }, { cooperation: { status: 'running', session: session_id, level: coop_job } })
          })
          .then(result => {
            return resolve(undefined)
          })
          .catch(error => {
            return reject(error)
          })
      }
    })
  })
}

/**
* go through rules defining what job the player is ought to play next based on  current parameters.
*
* @todo abfragen z.b. nach area ob im 2. oder 3. job rick miller
*
* @returns {Promise} name of job the player should be assigned to next
*/
function nextJob(args, refs) {
  return new Promise((resolve, reject) => {
    let name = "nextJob function"
    reference = refs.variables.getReference(args[0])
    if (!reference) {
      log.error(name, "coldnt resolve player reference " + args[0])
      return resolve(undefined)
    }

    var player = {}

    refs.db.player.find(reference.query)
      .then(result => {
        if (!result.length) {
          log.error(name, "no player found by query: " + reference.query)
          return resolve(undefined)
        }
        player = result[0]

        if (player.finished_jobs.length == 2) {
          if (player.area == 1) {
            if (player.language == "en") {
              return resolve("wtf_A1_EN")
            }
            return resolve("wtf_A1")
          } else {
            if (player.language == "en") {
              return resolve("wtf_A2_EN")
            }
            return resolve("wtf_A2")
          }
        } else if (player.finished_jobs.length == 3) {
          if (player.area == 1) {
            if (player.language == "en") {
              return resolve("carwatch_A1_EN")
            }
            return resolve("carwatch_A1")
          } else {
            if (player.language == "en") {
              return resolve("carwatch_A2_EN")
            }
            return resolve("carwatch_A2")
          }
        } else if (player.finished_jobs.length == 5) {
          if (player.language == "en") {
            return resolve("stabbing_EN")
          }
          return resolve("stabbing")
        }


        let query = {
          name: { $not: { $in: player.finished_jobs } }, // player has not played level (obligatory)
          'config.family': { $not: { $in: player.finished_jobs } }, // player has not played any level of the family (obligatory)
          'config.area': player.area, // level is in same area the player is in (obligatory)
          'config.type': 'job', // obligatory
          'config.language': player.language, // obligatory
          //'config.group': { $ne: player.progress }, // obligatory
          // 'config.stage':player.stage, // level is of same stage the player is in
          $expr: { $lt: ["$instances", "$config.maxSessions"] } // find only levels where max number of players is not reached. Uses aggregate expression: https://docs.mongodb.com/manual/reference/operator/query/expr/
        }
        return refs.db.level.c.find(query).sort({ instances: 1, 'config.priority': -1 }).toArray() // sort so level with least players is lowest index
      })
      .then(result => {
        if (!result) {
          return resolve(result)
        }
        if (typeof result === "string") {
          return resolve(result)
        }
        //log.debug("FIRST TRY", result)
        if (result.length) {
          return result[0].name // resolve with level played by the least players
        }

        // try another query allowing lower stage levels and ignoring if the maximum count of players is exceeded. This should always return a level!
        let query = {
          name: { $not: { $in: player.finished_jobs } }, // player has not played level (obligatory)
          'config.family': { $not: { $in: player.finished_jobs } }, // player has not played any level of the family (obligatory)
          //'config.group': { $ne: player.progress }, // obligatory
          'config.type': 'job', // obligatory
          'config.language': player.language, // obligatory
          'config.area': player.area, // level is in same area the player is in (obligatory)
          'config.overload': { $ne: false }
          // 'config.stage':{$lte:player.stage} // allow level with same stage or lower
        }
        return refs.db.level.c.find(query).sort({ instances: 1, 'config.priority': -1 }).toArray() // sort so level with least players is lowest index
      })
      .then(result => {
        if (!result) {
          return resolve(result)
        }
        if (typeof result === "string") {
          return resolve(result)
        }

        if (result.length) {
          log.warn(name, "No vacant level left to assign. Assigning occupied level " + result[0].name)
          return resolve(result[0].name)
        }
        log.error(name, "did not find a suitable level. This should not happen!")
        return resolve("error")
      })
      .catch(error => {
        log.error(this.name, error)
        return resolve("error")
      })
  })
}

module.exports = {
  test: test,
  timestamp: timestamp,
  getPlace: getPlace,
  assignIntro: assignIntro,
  checkQueue: checkQueue,
  updateQueue: updateQueue,
  assignStory: assignStory,
  getReader: getReader,
  assignTaskC: assignTaskC,
  since: since,
  left: left,
  jobData: jobData,
  startValues: startValues,
  nextJob: nextJob,
  cooperation: cooperation,
  attendance: attendance,
  getLoginLink: getLoginLink,
  getLocationText: getLocationText,
  cancelSessions: cancelSessions,
  cancelPlayerSessions: cancelPlayerSessions
}
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-plugin-Collection.html">Collection</a></li><li><a href="module-plugin-Item.html">Item</a></li><li><a href="module-plugin-Plugin.html">Plugin</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Tue Dec 17 2019 17:26:50 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
